<?php

/**
 * @file
 * User authenticate API admin pages.
 */

/**
 * Form callback for settings page.
 */
function user_auth_api_settings_page() {
  $form = array();

  $auth = user_auth_api();
  $auth->instantiatePlugins();

  $header = array(t('plugin name'), t('Description'), t('Class'), t('External'), t('Weight'));
  $rows = array();

  foreach ($auth->sortPluginsByWeight() as $name => $plugin_info) {
    $plugin = $plugin_info['plugin'];
    $row = array(
      // This can only be a valid class name.
      "<strong>$name</strong>",
      $plugin_info['info']['description'],
      $plugin_info['info']['plugin'],
      $plugin->isExternal() ? t('Yes') : t('No'),
      $plugin_info['weight'],
    );
    $rows[] = $row;
  }

  $form['user_auth_api_plugins'] = array(
    '#type' => 'fieldset',
    '#title' => t('Available plugins'),
  );
  $form['user_auth_api_plugins']['table'] = array(
    '#type' => 'markup',
    '#value' => theme('table', $header, $rows),
  );

  $form['disable_fieldset'] = array(
    '#type' => 'fieldset',
  );

  $form['disable_fieldset']['user_auth_api_disable'] = array(
    '#type' => 'checkbox',
    '#title' => t('Disable User authentication validation'),
    '#description' => t('Disable Any User authentication API plugins being called.'),
    '#default_value' => variable_get('user_auth_api_disable', FALSE),
  );

  return system_settings_form($form);
}
